import java.util.List;
import java.util.ArrayList;

public class SimpleQueue  { //Implemented with List/ArrayList, not array


	//Constructors
	public SimpleQueue (int initialSize) throws IllegalArgumentException {
		q = new ArrayList<Object>(initialSize);
	}


	public SimpleQueue ()
	{this(1);}



	//Mutators  
	public void makeEmpty () {
		q.clear();
	}


	public void enqueue (Object o) {
		q.add(o);
	}


	public Object dequeue () throws IllegalStateException {
		if ( q.isEmpty() )
			throw new IllegalStateException("SimpleQueue dequeue: queue is empty");

		return q.remove(0);
	}



	//Accessors
	public Object peek () throws IllegalStateException {
		if ( q.isEmpty() )
			throw new IllegalStateException("SimpleQueue peek: queue is empty");

		return q.get(0);  
	}


	public boolean isEmpty ()
	{return q.isEmpty();}



	public int getSize ()
	{return q.size();}


	public String toString () {
		String answer = "SimpleQueue[size="+q.size();
		for (int i=0; i<=q.size(); i++)
			answer += ";q["+i+"]="+q.get(i);
		answer +=  "]";

		return answer;
	}



	//Instance Variables  
	private List<Object> q;
}
